diff --git a/Documentation/ABI/testing/sysfs-bus-iio b/Documentation/ABI/testing/sysfs-bus-iio
index 6e02c50..0341b2f 100644
--- a/Documentation/ABI/testing/sysfs-bus-iio
+++ b/Documentation/ABI/testing/sysfs-bus-iio
@@ -165,6 +165,10 @@ Description:
 What:		/sys/bus/iio/devices/iio:deviceX/in_magn_x_raw
 What:		/sys/bus/iio/devices/iio:deviceX/in_magn_y_raw
 What:		/sys/bus/iio/devices/iio:deviceX/in_magn_z_raw
+What:		/sys/bus/iio/devices/iio:deviceX/in_magn_north_raw
+What:		/sys/bus/iio/devices/iio:deviceX/in_magn_north_true_raw
+What:		/sys/bus/iio/devices/iio:deviceX/in_magn_north_tilt_comp_raw
+What:		/sys/bus/iio/devices/iio:deviceX/in_magn_north_true_tilt_comp_raw
 KernelVersion:	2.6.35
 Contact:	linux-iio@vger.kernel.org
 Description:
@@ -249,6 +253,10 @@ What:		/sys/bus/iio/devices/iio:deviceX/in_magn_scale
 What:		/sys/bus/iio/devices/iio:deviceX/in_magn_x_scale
 What:		/sys/bus/iio/devices/iio:deviceX/in_magn_y_scale
 What:		/sys/bus/iio/devices/iio:deviceX/in_magn_z_scale
+What:		/sys/bus/iio/devices/iio:deviceX/in_magn_north_scale
+What:		/sys/bus/iio/devices/iio:deviceX/in_magn_north_true_scale
+What:		/sys/bus/iio/devices/iio:deviceX/in_magn_north_tilt_comp_scale
+What:		/sys/bus/iio/devices/iio:deviceX/in_magn_north_true_tilt_comp_scale
 What:		/sys/bus/iio/devices/iio:deviceX/in_pressureY_scale
 What:		/sys/bus/iio/devices/iio:deviceX/in_pressure_scale
 KernelVersion:	2.6.35
@@ -436,6 +444,14 @@ What:		/sys/.../iio:deviceX/events/in_magn_y_thresh_rising_en
 What:		/sys/.../iio:deviceX/events/in_magn_y_thresh_falling_en
 What:		/sys/.../iio:deviceX/events/in_magn_z_thresh_rising_en
 What:		/sys/.../iio:deviceX/events/in_magn_z_thresh_falling_en
+What:		/sys/.../iio:deviceX/events/in_magn_north_thresh_rising_en
+What:		/sys/.../iio:deviceX/events/in_magn_north_thresh_falling_en
+What:		/sys/.../iio:deviceX/events/in_magn_north_true_thresh_rising_en
+What:		/sys/.../iio:deviceX/events/in_magn_north_true_thresh_falling_en
+What:		/sys/.../iio:deviceX/events/in_magn_north_tilt_comp_thresh_rising_en
+What:		/sys/.../iio:deviceX/events/in_magn_north_tilt_comp_thresh_falling_en
+What:		/sys/.../iio:deviceX/events/in_magn_north_true_tilt_comp_thresh_rising_en
+What:		/sys/.../iio:deviceX/events/in_magn_north_true_tilt_comp_thresh_falling_en
 What:		/sys/.../iio:deviceX/events/in_voltageY_supply_thresh_rising_en
 What:		/sys/.../iio:deviceX/events/in_voltageY_supply_thresh_falling_en
 What:		/sys/.../iio:deviceX/events/in_voltageY_thresh_rising_en
@@ -481,6 +497,14 @@ What:		/sys/.../iio:deviceX/events/in_magn_y_roc_rising_en
 What:		/sys/.../iio:deviceX/events/in_magn_y_roc_falling_en
 What:		/sys/.../iio:deviceX/events/in_magn_z_roc_rising_en
 What:		/sys/.../iio:deviceX/events/in_magn_z_roc_falling_en
+What:		/sys/.../iio:deviceX/events/in_magn_north_roc_rising_en
+What:		/sys/.../iio:deviceX/events/in_magn_north_roc_falling_en
+What:		/sys/.../iio:deviceX/events/in_magn_north_true_roc_rising_en
+What:		/sys/.../iio:deviceX/events/in_magn_north_true_roc_falling_en
+What:		/sys/.../iio:deviceX/events/in_magn_north_tilt_comp_roc_rising_en
+What:		/sys/.../iio:deviceX/events/in_magn_north_tilt_comp_roc_falling_en
+What:		/sys/.../iio:deviceX/events/in_magn_north_true_tilt_comp_roc_rising_en
+What:		/sys/.../iio:deviceX/events/in_magn_north_true_tilt_comp_roc_falling_en
 What:		/sys/.../iio:deviceX/events/in_voltageY_supply_roc_rising_en
 What:		/sys/.../iio:deviceX/events/in_voltageY_supply_roc_falling_en
 What:		/sys/.../iio:deviceX/events/in_voltageY_roc_rising_en
@@ -527,6 +551,14 @@ What:		/sys/.../events/in_magn_y_raw_thresh_rising_value
 What:		/sys/.../events/in_magn_y_raw_thresh_falling_value
 What:		/sys/.../events/in_magn_z_raw_thresh_rising_value
 What:		/sys/.../events/in_magn_z_raw_thresh_falling_value
+What:		/sys/.../events/in_magn_north_raw_thresh_rising_value
+What:		/sys/.../events/in_magn_north_raw_thresh_falling_value
+What:		/sys/.../events/in_magn_north_true_raw_thresh_rising_value
+What:		/sys/.../events/in_magn_north_true_raw_thresh_falling_value
+What:		/sys/.../events/in_magn_north_tilt_comp_raw_thresh_rising_value
+What:		/sys/.../events/in_magn_north_tilt_comp_raw_thresh_falling_value
+What:		/sys/.../events/in_magn_north_true_tilt_comp_raw_thresh_rising_value
+What:		/sys/.../events/in_magn_north_true_tilt_comp_raw_thresh_falling_value
 What:		/sys/.../events/in_voltageY_supply_raw_thresh_rising_value
 What:		/sys/.../events/in_voltageY_supply_raw_thresh_falling_value
 What:		/sys/.../events/in_voltageY_raw_thresh_rising_value
@@ -577,6 +609,18 @@ What:		/sys/.../events/in_magn_y_thresh_either_hysteresis
 What:		/sys/.../events/in_magn_z_thresh_rising_hysteresis
 What:		/sys/.../events/in_magn_z_thresh_falling_hysteresis
 What:		/sys/.../events/in_magn_z_thresh_either_hysteresis
+What:		/sys/.../events/in_magn_north_thresh_rising_hysteresis
+What:		/sys/.../events/in_magn_north_thresh_falling_hysteresis
+What:		/sys/.../events/in_magn_north_thresh_either_hysteresis
+What:		/sys/.../events/in_magn_north_true_thresh_rising_hysteresis
+What:		/sys/.../events/in_magn_north_true_thresh_falling_hysteresis
+What:		/sys/.../events/in_magn_north_true_thresh_either_hysteresis
+What:		/sys/.../events/in_magn_north_tilt_comp_thresh_rising_hysteresis
+What:		/sys/.../events/in_magn_north_tilt_comp_thresh_falling_hysteresis
+What:		/sys/.../events/in_magn_north_tilt_comp_thresh_either_hysteresis
+What:		/sys/.../events/in_magn_north_true_tilt_comp_thresh_rising_hysteresis
+What:		/sys/.../events/in_magn_north_true_tilt_comp_thresh_falling_hysteresis
+What:		/sys/.../events/in_magn_north_true_tilt_comp_thresh_either_hysteresis
 What:		/sys/.../events/in_voltageY_thresh_rising_hysteresis
 What:		/sys/.../events/in_voltageY_thresh_falling_hysteresis
 What:		/sys/.../events/in_voltageY_thresh_either_hysteresis
@@ -624,6 +668,14 @@ What:		/sys/.../events/in_magn_y_raw_roc_rising_value
 What:		/sys/.../events/in_magn_y_raw_roc_falling_value
 What:		/sys/.../events/in_magn_z_raw_roc_rising_value
 What:		/sys/.../events/in_magn_z_raw_roc_falling_value
+What:		/sys/.../events/in_magn_north_raw_roc_rising_value
+What:		/sys/.../events/in_magn_north_raw_roc_falling_value
+What:		/sys/.../events/in_magn_north_true_raw_roc_rising_value
+What:		/sys/.../events/in_magn_north_true_raw_roc_falling_value
+What:		/sys/.../events/in_magn_north_tilt_comp_raw_roc_rising_value
+What:		/sys/.../events/in_magn_north_tilt_comp_raw_roc_falling_value
+What:		/sys/.../events/in_magn_north_true_tilt_comp_raw_roc_rising_value
+What:		/sys/.../events/in_magn_north_true_tilt_comp_raw_roc_falling_value
 What:		/sys/.../events/in_voltageY_supply_raw_roc_rising_value
 What:		/sys/.../events/in_voltageY_supply_raw_roc_falling_value
 What:		/sys/.../events/in_voltageY_raw_roc_rising_value
@@ -679,6 +731,22 @@ What:		/sys/.../events/in_magn_z_thresh_rising_period
 What:		/sys/.../events/in_magn_z_thresh_falling_period
 What:		/sys/.../events/in_magn_z_roc_rising_period
 What:		/sys/.../events/in_magn_z_roc_falling_period
+What:		/sys/.../events/in_magn_north_thresh_rising_period
+What:		/sys/.../events/in_magn_north_thresh_falling_period
+What:		/sys/.../events/in_magn_north_roc_rising_period
+What:		/sys/.../events/in_magn_north_roc_falling_period
+What:		/sys/.../events/in_magn_north_true_thresh_rising_period
+What:		/sys/.../events/in_magn_north_true_thresh_falling_period
+What:		/sys/.../events/in_magn_north_true_roc_rising_period
+What:		/sys/.../events/in_magn_north_true_roc_falling_period
+What:		/sys/.../events/in_magn_north_tilt_comp_thresh_rising_period
+What:		/sys/.../events/in_magn_north_tilt_comp_thresh_falling_period
+What:		/sys/.../events/in_magn_north_tilt_comp_roc_rising_period
+What:		/sys/.../events/in_magn_north_tilt_comp_roc_falling_period
+What:		/sys/.../events/in_magn_north_true_tilt_comp_thresh_rising_period
+What:		/sys/.../events/in_magn_north_true_tilt_comp_thresh_falling_period
+What:		/sys/.../events/in_magn_north_true_tilt_comp_roc_rising_period
+What:		/sys/.../events/in_magn_north_true_tilt_comp_roc_falling_period
 What:		/sys/.../events/in_voltageY_supply_thresh_rising_period
 What:		/sys/.../events/in_voltageY_supply_thresh_falling_period
 What:		/sys/.../events/in_voltageY_supply_roc_rising_period
@@ -776,6 +844,10 @@ What:		/sys/.../iio:deviceX/scan_elements/in_anglvel_z_en
 What:		/sys/.../iio:deviceX/scan_elements/in_magn_x_en
 What:		/sys/.../iio:deviceX/scan_elements/in_magn_y_en
 What:		/sys/.../iio:deviceX/scan_elements/in_magn_z_en
+What:		/sys/.../iio:deviceX/scan_elements/in_magn_north_en
+What:		/sys/.../iio:deviceX/scan_elements/in_magn_north_true_en
+What:		/sys/.../iio:deviceX/scan_elements/in_magn_north_tilt_comp_en
+What:		/sys/.../iio:deviceX/scan_elements/in_magn_north_true_tilt_comp_en
 What:		/sys/.../iio:deviceX/scan_elements/in_timestamp_en
 What:		/sys/.../iio:deviceX/scan_elements/in_voltageY_supply_en
 What:		/sys/.../iio:deviceX/scan_elements/in_voltageY_en
@@ -840,6 +912,10 @@ What:		/sys/.../iio:deviceX/scan_elements/in_anglvel_z_index
 What:		/sys/.../iio:deviceX/scan_elements/in_magn_x_index
 What:		/sys/.../iio:deviceX/scan_elements/in_magn_y_index
 What:		/sys/.../iio:deviceX/scan_elements/in_magn_z_index
+What:		/sys/.../iio:deviceX/scan_elements/in_magn_north_index
+What:		/sys/.../iio:deviceX/scan_elements/in_magn_north_true_index
+What:		/sys/.../iio:deviceX/scan_elements/in_magn_north_tilt_comp_index
+What:		/sys/.../iio:deviceX/scan_elements/in_magn_north_true_tilt_comp_index
 What:		/sys/.../iio:deviceX/scan_elements/in_incli_x_index
 What:		/sys/.../iio:deviceX/scan_elements/in_incli_y_index
 What:		/sys/.../iio:deviceX/scan_elements/in_timestamp_index